/* -*-C-*-
 ******************************************************************************
 *
 * File:         psopt.h
 * RCS:          $Header: /home/chris/Psopt/cvs/psopt/src/psopt.h,v 1.1 1997/06/20 00:36:56 chris Exp $
 * Description:  
 * Author:       Christian Limpach <chris@nice.ch>
 * Created:      Wed Jun 18 23:50:05 1997
 * Modified:     Thu Jun 19 03:24:10 1997 (Christian Limpach) chris@nice.ch
 * Language:     C
 * Package:      N/A
 * Status:       Experimental (Do Not Distribute)
 *
 * (C) Copyright 1997, Christian Limpach, all rights reserved.
 *            
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *            
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *            
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, a copy can be obtained from this
 * program's author (send electronic mail to chris@nice.ch) or from
 * the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA
 * 02139, USA.
 *
 ******************************************************************************
 */

#include "config.h"
#include "sysdep.h"
#include "idents.h"

/* */
enum code_type
{
  ARGUMENT, COMMAND, DIRECT, STRING, BINSTRING, COMMENT,
  OPEN_BRACE, CLOSE_BRACE, OPEN_BRACKET, CLOSE_BRACKET,
  START
};

struct code
{
  enum code_type type;
  
  union
  {
    Identifier *argument;
    Identifier *command;
    Identifier *direct;
    char *string;
    char *binstring;
    char *comment;
    void *empty;
  } d;

  struct code *next;
};
typedef struct code Code;

/* psopt.c */
extern void add_code (enum code_type type, void *d);

/* input.c */
extern void input_argument (Identifier *);
extern void input_command (Identifier *);
extern void input_direct (Identifier *);
extern void input_string (char *);
extern void input_binstring (char *);
extern void input_comment (char *);
extern void input_open_brace (void);
extern void input_close_brace (void);
extern void input_open_bracket (void);
extern void input_close_bracket (void);

/* various declarations */
#ifndef NULL
#define NULL 0
#endif
